#! /usr/bin/python3

# produit une page HTML d'un tableau de plusieurs chronologies parallèles
# écrit en python2; en python3 le 2016.05.09 et finalisé le 2025.01.06
# jchr.be/python/chronologie.htm
# GPLv3, voir https://www.gnu.org/licenses/quick-guide-gplv3.fr.html

# en débogage !

import sys, glob, collections

#  C H O I X   D U   F I C H I E R

repert =sorted(glob.glob("*.dat"))  # sélectionne les fichiers.dat
nbf =len(repert)           # nombre de fichiers trouvés

if len(repert) > 1 :
  choix=[]  # liste des choix (chaînes numériques)
  for i in range(nbf) : # liste les fichiers '.dat'
    print(f" {i:2}  {repert[i]}")
    choix +=[str(i)]
  print() ; q =""
  while q not in choix :  # choix du fichier
    q =input("Numéro du fichier: ")
  rep =repert[int(q)]
else :
  if len(repert) ==1 : # choix automatique s'il n'y a qu'un fichier
    rep =repert[0]
  else :
    input("\n  Pas de fichier .dat dans le répertoire\n")
    sys.exit()

with open(f"{rep}") as df : # ouverture du fichier choisi
  texte =df.read()
dates =texte.split("\n")
print("\n", f" Traitement du fichier '{rep}'")

#  C O L L E C T E   D E S   D O N N É E S

tab =collections.OrderedDict() ; signes =[] ; coul ="" ; col =0
orig =10 **10 ; jusq =-orig ; titre ="" ; laius =[] ; nbs =0
bgp ="fff" ; fgp ="000" ; ibp ="008" ; lkp ="b04" # texte en dehors du tableau
bgc ="fff" ; fgc ="000" # fond et texte par défaut de la colonne des dates

for i in dates:
  if "#" in i : i =i.split("#", 1)[0] # enlève les commentaires
  i =i.strip()
  if not i : continue
  if i[1] =="=" : # couleurs dévolues aux classes selon selon préfixes
    signe, dn =i.split("=", 1)
    bg ="fff" ; fg ="000" ; ib ="008" ; lk ="b04"
    morc =dn.split("=")
    # input(morc)
    if len(morc) > 0 and morc[0] : bg =morc[0]
    if len(morc) > 1 and morc[1] : fg =morc[1]
    if signe =="_" : # si concerne la colonne des dates
      col =nbs +1 ; bgc =bg ; fgc =fg ; continue
    if signe ==":" : # titre et paragraphes
      bgp =bg ; fgp =fg
    else :
      coul +=f".{chr(97 +nbs)} {{ background:#{bg}; color:#{fg}; }}\n"
    if len(morc) > 2 and morc[2] :
      ib =morc[2]
      if signe !=":" :
        coul +=f"td.{chr(97 +nbs)} s {{ color:#{ib}; }}\n"
      else :
        ibp =ib
    if len(morc) > 3 and morc[3] :
      lk =morc[3]
      if signe !=":" :
        coul +=f"td.{chr(97 +nbs)} a {{ color:#{lk}; }}\n"
      else :
        lkp =lk
    if signe !=":" :
      tab[signe]=[] ; signes +=signe ; nbs +=1
    continue
  if " " in i :
    if i[0] not in tab and i[0] !=":" :
      print(f"Le préfixe {i[0]} n'est pas défini («{i}»)") ; continue  # préfixe non défini?
    deb, texte =i.split(" ", 1)
    if i[0] ==":" :
      laius +=[texte] ; continue
    para =""
    if "§" in texte[1:] :   # traitement des infos-bulles
      texte, para =texte.split("§")
      texte =f"""<s class="cp"><s>{para}</s>{texte}</s> """
    date =int(deb[1:]) ; cle =i[0]
    if date < orig : orig =date
    if date > jusq : jusq =date
    tab[cle] +=[[date, texte]]
  else :
    input(f"{i} non traitée")

for i in range(len(signes)-1, -1, -1) : # réduction des signes définis inutilisés
  if not tab[signes[i]] :
    tab.pop(signes[i]) # ???
    signes.pop(i)

# A G R E G A T I O N   M Ê M E S   D A T E S   /   P R É F I X E S

for i in signes :
  for j in range(len(tab[i]) -2, -1, -1):
    if tab[i][j][0] ==tab[i][j +1][0]:
      tab[i][j][1] +=f"<br>{tab[i][j +1][1]}"
      tab[i].pop(j +1)

# C O N S T I T U T I O N   D E S   C E L L U L E S   ( R O W S P A N )

lignes =[]
for i in range(orig, jusq +1): # colonne des dates
  dt =str(i)
  if dt =="0" : dt =""
  lignes +=[f"<th>{dt}"]

# agrégation des colonnes avant la colonne des années, à rebours
err =0
for j in range(col -2, -1, -1) :
  cle =signes[j]

# remplir un éventuel vide avant le premier fait
  init =int(tab[cle][0][0])
  if init !=orig :
    lignes[0] =f"""<td class="{chr(97 +j)}" rowspan="{str(int(init) -orig)}">{lignes[0]}"""

# traitement des dates
  prec =orig
  for i in range(len(tab[cle])) :
    date =tab[cle][i][0] ; fait =tab[cle][i][1]
    if date -prec <0 :
      input(f"Attention : !{date} après !{prec} : {fait}") ; err +=1
    prec =date
    try:
      jusque =tab[cle][i +1][0]
    except:
      jusque =jusq +1
    lignes[date -orig]=f"""<td class="{chr(97 +j)}" rowspan="{str(jusque -date)}">{fait}{lignes[date -orig]}"""

# agrégation des colonnes après celle des années

for j in range(col -1, len(signes)) :
  cle =signes[j]

# remplir un éventuel vide avant le premier fait
  init =int(tab[cle][0][0])
  if init !=orig :
    lignes[0] =f"""{lignes[0]}<td class="{chr(97 +j)}" rowspan="{str(int(init) -orig)}">"""

# traitement des dates
  prec =orig
  for i in range(len(tab[cle])) :
    date =tab[cle][i][0] ; fait =tab[cle][i][1]
    if date -prec <0 :
      input(f"Attention : !{date} après !{prec} : {fait}") ; err +=1
    prec =date
    try:
      jusque =tab[cle][i +1][0]
    except:
      jusque =jusq +1
    lignes[date -orig]=f"""{lignes[date -orig]}<td class="{chr(97 +j)}" rowspan="{str(jusque -date)}">{fait}"""

# rejoindre les lignes

html ="\n<tr>\n".join(lignes)

html =html.replace(' rowspan="1"', "") # élimination de l'inutile
html =html.replace("=>", "→")
html =html.replace("+/-", "&plusmn;")
html =html.replace("(+", "(&dagger;")
if laius :
  titre =laius[0]
  laius ="\n<p>\n".join(laius[1:])
else :
  laius =""

footer =""
if jusque -orig > 50 : # si le tableau est assez long
  footer ="""<footer><a href="#top">haut</a></footer>"""

fich =f"""<!doctype html>
<html lang="fr"><head>
<title>{titre}</title>
<meta name="author" content="www.jchr.be">
<meta name="robots" content="none">
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<style>
body {{ font-family:sans; color:#{fgp}; background:#{bgp}; }}
table {{ border-collapse:collapse }}
a {{ text-decoration:none; font-weight:bold; color:#{lkp}; }}
th,td {{ border:1px solid #777; border-right:1px solid #777; vertical-align:top; padding-left:3px }}
th {{ text-align:right; font-size:1em; color:#{fgc}; background:#{bgc}; }}
{coul}
s {{ color:#{ibp}; text-decoration:none; }}
s:hover, s:active {{ color:#000; background:#fff; }}
s s {{ display:none; text-decoration:none; width:33%; color:#000; background:#fff; }}
s:hover s, s:active s
{{ display:inline; position:absolute; color:#111; background:#fff; padding:1px 6px 2px; border:ridge 3px #777; }}
p {{ margin:0 1em .5em }}
h1 {{ margin:0.2em 0.2em .5em }}
footer {{ border-top:1px solid #777; margin-top:.7em; padding-top:.3em; }}
</style>
</head><body id="top">

<h1>{titre}</h1>
<p>
{laius}
<table><tr>
{html}
</table>
{footer}
</body></html>"""

nfich =f"""{rep.rsplit(".", 1)[0]}.htm"""
with open(f"{nfich}", "w") as df :
  df.write(fich)

if err :
  print("\n", f" {err} erreur·s constatée·s, tableau probablement dérangé", "\n")

input(f"  Fichier '{nfich}' sauvegardé\n")

